<template>
  <div class="container">
    <q-btn
      v-if="!liveLeaderboardPaused"
      class="q-mt-md"
      color="primary"
      label="Pause Live Leaderboard"
      icon="pause"
      @click="pauseLeaderboard"
    />
    <q-btn
      v-if="liveLeaderboardPaused"
      class="q-mt-md"
      color="green"
      label="Resume Live Leaderboard"
      icon="play_arrow"
      @click="resumeLeaderboard"
    />
    <br />
    <q-toggle
      class="q-my-md"
      :value="pluginEnabled"
      label="Show leaderboard overlay"
      @input="() => togglePluginEnabled()"
    />
    <q-list class="q-mb-sm" bordered separator>
      <q-item
        style="align-items: center"
        v-for="(team, id, index) in teams"
        :key="id"
      >
        <q-item-section class="team-name">
          <q-item-label>{{ team.teamName }}</q-item-label
          ><q-item-label caption
            >Score:
            <strong>{{ teamsTotalScores[id] || 0 }}</strong></q-item-label
          ></q-item-section
        ><q-item-section avatar
          ><q-btn
            class="col"
            color="negative"
            label="-1"
            icon="arrow_downward"
            @click="() => awardBonusPoints(String(id), -1)"
        /></q-item-section>
        <q-item-section avatar>
          <q-btn
            class="col"
            color="green"
            label="+1"
            icon="arrow_upward"
            @click="() => awardBonusPoints(String(id), +1)"
          />
        </q-item-section>
      </q-item>
    </q-list>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { scoreEventsReducer } from "./scoreEventsReducer";
import { Teams } from "./team";
import { ScoreEvents } from "./scoreEvent";
import { ZoomSenseClientFirebaseDB } from "@zoomsense/zoomsense-firebase";
import { ZoomSenseConfigCurrentStatePlugins } from "@zoomsense/zoomsense-firebase/lib/types/zoomSenseConfig";

export default Vue.extend({
  props: {
    firebase: {
      required: true,
      type: Object as () => ZoomSenseClientFirebaseDB,
    },
    context: {
      required: true,
      type: Object as () => { meetingid: string },
    },
  },
  data() {
    return {
      scoreEvents: undefined as undefined | ScoreEvents,
      teams: undefined as undefined | Teams,
      config: undefined as
        | undefined
        | ZoomSenseConfigCurrentStatePlugins["trivialeaderboardoverlay"],
    };
  },
  created() {
    console.log("Dashboard created");
  },
  methods: {
    awardBonusPoints(teamId: string, points: number): void {
      this.firebase
        .ref(
          `/data/plugins/trivialeaderboardoverlay/${this.context.meetingid}/scoreEvents`
        )
        .push({ amount: points, teamId });
    },
    pauseLeaderboard(): void {
      this.firebase
        .ref(
          `/config/${this.context.meetingid}/current/currentState/plugins/trivialeaderboardoverlay`
        )
        .update({ liveLeaderboardPaused: true });
    },
    resumeLeaderboard(): void {
      this.firebase
        .ref(
          `/config/${this.context.meetingid}/current/currentState/plugins/trivialeaderboardoverlay`
        )
        .update({ liveLeaderboardPaused: false });
    },
    togglePluginEnabled(): void {
      this.firebase
        .ref(
          `/config/${this.context.meetingid}/current/currentState/plugins/trivialeaderboardoverlay`
        )
        .update({ enabled: !this.config?.enabled });
    },
  },
  computed: {
    teamsTotalScores(): Record<string, number> {
      if (!this.scoreEvents || !this.teams) {
        return {};
      }
      return Object.values(this.scoreEvents).reduce(
        scoreEventsReducer,
        {} as Record<string, number>
      );
    },
    liveLeaderboardPaused(): boolean | undefined {
      return this.config?.liveLeaderboardPaused;
    },
    pluginEnabled(): boolean | undefined {
      return this.config?.enabled;
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        console.log(
          (
            await this.firebase
              .ref(
                `config/${this.context.meetingid}/current/currentState/plugins/trivialeaderboardoverlay`
              )
              .once("value")
          ).val()
        );
        await this.$typedRtdbBind(
          "config",
          this.firebase.ref(
            `config/${this.context.meetingid}/current/currentState/plugins/trivialeaderboardoverlay`
          )
        );

        await this.$typedRtdbBind(
          "scoreEvents",
          this.firebase.ref(
            `/data/plugins/trivialeaderboardoverlay/${this.context.meetingid}/scoreEvents`
          )
        );

        await this.$typedRtdbBind(
          "teams",
          this.firebase.ref(
            `/data/plugins/teamPlugin/${this.context.meetingid}`
          )
        );
      },
    },
  },
});
</script>

<style scoped>
.container {
  max-width: 40rem;
}
</style>
